Subject: Re: [PATCH v2 net-next 1/4] net: socket: add support for async operations

From: Al Viro <[email-masked]>
Date: Thu, 19 Mar 2015 16:20:24 +0000

On Mon, Mar 16, 2015 at 09:15:14AM -0700, Tadeusz Struk wrote:
> Add support for async operations.

NAK.  For the same reason as the last time - 

> +static ssize_t sock_aio_read(struct kiocb *iocb, const struct iovec *iov,
> +			     unsigned long nr_segs, loff_t loff);
> +static ssize_t sock_aio_write(struct kiocb *iocb, const struct iovec *iov,
> +			      unsigned long nr_segs, loff_t loff);
> +

is completely pointless.  Just have sock_read_iter() and sock_write_iter()
check if your new methods are present and use those if those are.

What's more, I'm not at all sure that you want to pass iocb that way -
kernel-side msghdr isn't tied to userland one anymore, so we might as well
stash a pointer to iocb into it.  Voila - no new methods needed at all.